[Beowulf] best linux distribution

Tony Travis ajt at rri.sari.ac.uk
Mon Oct 8 17:25:07 EDT 2007


Mark Hahn wrote:
 >> What I like about APT (the Debian package manager) is the dependency 
checking and conflict resolution capabilities of "aptitude", which is 
more robust than
 >
 > I'm curious - how does a conflict happen, and how is it resolved?
 > I guess that this must have to do with packages which specify 
particular versions of packages they depend on, or perhaps minimal
 > versions of them.  but a conflict seems to imply that you'd have a 
package which ultimately has conflicting dependencies.

Hello, Mark.

Debian has a very large range of packages, some of which are known to 
conflict a priori because they solve similar problems, but they are 
maintained by different people with different objectives. Each package 
maintainer has a responsibility to declare known conflicts with other 
packages. However, the permutations of packages that could be combined 
in an installation are also very large. APT tracks files that are used 
in all packages and automatically detects conflicts. The APT conflict 
resolver suggests strategies to solve problems like this, and also the 
dependencies that are caused by package upgrades. It's not a new idea, 
but it works very well.

This statement is in the current Debian release notes:

"2.1.1 Package management

aptitude is the preferred program for package management from console. 
aptitude supports most command line operations of apt-get and has proven 
to be better at dependency resolution than apt-get. If you are still 
using dselect, you should switch to aptitude as the official frontend 
for package management.

For etch an advanced conflict resolving mechanism has been implemented 
in aptitude that will try to find the best solution if conflicts are 
detected because of changes in dependencies between packages."

http://www.debian.org/releases/stable/i386/release-notes/ch-whats-new.en.html

 > how often does this happen, and is it mainly the result of 
misconfiguration?

It doesn't happen very often, but when it does "aptitude" has got me out 
of several deep holes... It's not because of misconfiguration. It's 
because the 'topological' map of package dependencies is complex, and 
not all possible interactions between all packages can be anticipated 
because the search space of package combinations is extremely large.

 > and resolution is simply having multiple version of some depended-on 
package installed, right?

Sounds so easy, doesn't it ;-)

 >> the older "apt-get". I previously ran Red Hat 5.3->9 and I've used 
both "up2date" and "yum". Neither of these is as capable of resolving 
package conflicts and dependencies as APT. I used APT for RPM when I ran 
RH9 for exactly this reason.
 >
 > hmm, I've never had any problems with yum.

Fair enough, but I found that it placed more of the burden of package 
management on me than I wanted. APT for RPM was wonderful by comparison. 
I used it for several years until the Fedora Legacy Archive stopped 
supporting RH9. At this point I had already been evaluating Debian on 
one of our Beowulf servers, but I decided to use Ubuntu instead.

Best wishes,

     Tony.
-- 
Dr. A.J.Travis,                     |  mailto:ajt at rri.sari.ac.uk
Rowett Research Institute,          |    http://www.rri.sari.ac.uk/~ajt
Greenburn Road, Bucksburn,          |   phone:+44 (0)1224 712751
Aberdeen AB21 9SB, Scotland, UK.    |     fax:+44 (0)1224 716687
_______________________________________________
Beowulf mailing list, Beowulf at beowulf.org
To change your subscription (digest mode or unsubscribe) visit http://www.beowulf.org/mailman/listinfo/beowulf

!DSPAM:470aa077279971336712104!



More information about the Beowulf mailing list